DiceRoller = LibStub("AceAddon-3.0"):NewAddon("DiceRoller", "AceEvent-3.0")

function DiceRoller:OnEnable()
	self:RegisterEvent("CHAT_MSG_RAID")
	self:RegisterEvent("CHAT_MSG_RAID_LEADER")
end

-- main function for most users
function DiceRoller:CHAT_MSG_RAID(event, message, sender ,...)

	local count, size = string.match(message, "^!(%d+)[dD](%d+)$")
	if count and size then
		if tonumber(count) > 100 then
			SendChatMessage(sender..": Can't roll more than 100 die!", "RAID")
		elseif tonumber(size) > 100000 then
			SendChatMessage(sender..": Don't be stupid, no dice has more than 100000 sides!", "RAID")
		else
			local out = sender..": "
			local total = 0 	
			for i=1,tonumber(count) do
				local dice = math.random(1, tonumber(size))
				total = total + dice
				out = out..dice.." + "
			end
			out = string.sub(out, 0, -3)
			out = out.." = "..total.." ("..count.."d"..size..") "

			SendChatMessage(out, "RAID")
		end
	end

end

--ignore for now, it's just so everything is copacetic for the raid lead since that uses a different chat event; it's just the same code
function DiceRoller:CHAT_MSG_RAID_LEADER(event, message, sender ,...)

	local count, size = string.match(message, "^!(%d+)[dD](%d+)$")
	if count and size then
		if tonumber(count) > 100 then
			SendChatMessage(sender..": Can't roll more than 100 die!", "RAID")
		elseif tonumber(size) > 100000 then
			SendChatMessage(sender..": Don't be stupid, no dice has more than 100000 sides!", "RAID")
		else
			local out = sender..": "
			local total = 0
			for i=1,tonumber(count) do
				local dice = math.random(1, tonumber(size))
				total = total + dice
				out = out..dice.." + "
			end
			out = string.sub(out, 0, -3)
			out = out.." = "..total.." ("..count.."d"..size..") "

			SendChatMessage(out, "RAID")
		end
	end

end


--function DiceRoller:CHAT_MSG_RAID(event, message, sender ,...)

	--local count, size, modifier = string.match(message, "^!(%d+)[dD](%d+)+?(%d+)$")
	--if count and size then
	--	if tonumber(count) > 100 then
	--		SendChatMessage(sender..": Can't roll more than 100 die!", "RAID")
	--	elseif tonumber(size) > 100000 then
	--		SendChatMessage(sender..": Don't be stupid, no dice has more than 100000 sides!", "RAID")
	--	else
	--		local out = sender..": "
	--		local total = 0 	
	--		for i=1,tonumber(count) do
	--			local dice = math.random(1, tonumber(size))
	--			total = total + dice
	--			out = out..dice.." + "
	--		end
	--		total = total + modifier
	--		out = string.sub(out, 0, -3)
	--		out = out.. "+ "..modifier.." = "..total.." ("..count.."d"..size.."+"..modifier..") "
--
	--		SendChatMessage(out, "RAID")
	--	end
	--end

--end